diff --git a/src/decode-tcp.c b/src/decode-tcp.c
index 46ec32e..e132cab 100644
--- a/src/decode-tcp.c
+++ b/src/decode-tcp.c
@@ -8,128 +8,6 @@
 #include "util-debug.h"
 #include "flow.h"
 
-/**
- * \brief Calculates the checksum for the TCP packet
- *
- * \param shdr Pointer to source address field from the IP packet.  Used as a
- *             part of the psuedoheader for computing the checksum
- * \param pkt  Pointer to the start of the TCP packet
- * \param hlen Total length of the TCP packet(header + payload)
- *
- * \retval csum Checksum for the TCP packet
- */
-inline uint16_t TCPCalculateChecksum(uint16_t *shdr, uint16_t *pkt,
-                                     uint16_t tlen)
-{
-    uint16_t pad = 0;
-    uint32_t csum = shdr[0];
-
-    csum += shdr[1] + shdr[2] + shdr[3] + htons(6 + tlen);
-
-    csum += pkt[0] + pkt[1] + pkt[2] + pkt[3] + pkt[4] + pkt[5] + pkt[6] +
-        pkt[7] + pkt[9];
-
-    tlen -= 20;
-    pkt += 10;
-
-    while (tlen >= 32) {
-        csum += pkt[0] + pkt[1] + pkt[2] + pkt[3] + pkt[4] + pkt[5] + pkt[6] +
-            pkt[7] + pkt[8] + pkt[9] + pkt[10] + pkt[11] + pkt[12] + pkt[13] +
-            pkt[14] + pkt[15];
-        tlen -= 32;
-        pkt += 16;
-    }
-
-    while(tlen >= 8) {
-        csum += pkt[0] + pkt[1] + pkt[2] + pkt[3];
-        tlen -= 8;
-        pkt += 4;
-    }
-
-    while(tlen >= 4) {
-        csum += pkt[0] + pkt[1];
-        tlen -= 4;
-        pkt += 2;
-    }
-
-    while (tlen > 1) {
-        csum += pkt[0];
-        pkt += 1;
-        tlen -= 2;
-    }
-
-    if (tlen == 1) {
-        *(uint8_t *)(&pad) = (*(uint8_t *)pkt);
-        csum += pad;
-    }
-
-    csum = (csum >> 16) + (csum & 0x0000FFFF);
-
-    return (uint16_t) ~csum;
-}
-
-/**
- * \brief Calculates the checksum for the TCP packet
- *
- * \param shdr Pointer to source address field from the IPV6 packet.  Used as a
- *             part of the psuedoheader for computing the checksum
- * \param pkt  Pointer to the start of the TCP packet
- * \param tlen Total length of the TCP packet(header + payload)
- *
- * \retval csum Checksum for the TCP packet
- */
-inline uint16_t TCPV6CalculateChecksum(uint16_t *shdr, uint16_t *pkt,
-                                       uint16_t tlen)
-{
-    uint16_t pad = 0;
-    uint32_t csum = shdr[0];
-
-    csum += shdr[1] + shdr[2] + shdr[3] + shdr[4] + shdr[5] + shdr[6] +
-        shdr[7] + shdr[8] + shdr[9] + shdr[10] + shdr[11] + shdr[12] +
-        shdr[13] + shdr[14] + shdr[15] + htons(6 + tlen);
-
-    csum += pkt[0] + pkt[1] + pkt[2] + pkt[3] + pkt[4] + pkt[5] + pkt[6] +
-        pkt[7] + pkt[9];
-
-    tlen -= 20;
-    pkt += 10;
-
-    while (tlen >= 32) {
-        csum += pkt[0] + pkt[1] + pkt[2] + pkt[3] + pkt[4] + pkt[5] + pkt[6] +
-            pkt[7] + pkt[8] + pkt[9] + pkt[10] + pkt[11] + pkt[12] + pkt[13] +
-            pkt[14] + pkt[15];
-        tlen -= 32;
-        pkt += 16;
-    }
-
-    while(tlen >= 8) {
-        csum += pkt[0] + pkt[1] + pkt[2] + pkt[3];
-        tlen -= 8;
-        pkt += 4;
-    }
-
-    while(tlen >= 4) {
-        csum += pkt[0] + pkt[1];
-        tlen -= 4;
-        pkt += 2;
-    }
-
-    while (tlen > 1) {
-        csum += pkt[0];
-        pkt += 1;
-        tlen -= 2;
-    }
-
-    if (tlen == 1) {
-        *(uint8_t *)(&pad) = (*(uint8_t *)pkt);
-        csum += pad;
-    }
-
-    csum = (csum >> 16) + (csum & 0x0000FFFF);
-
-    return (uint16_t) ~csum;
-}
-
 static int DecodeTCPOptions(ThreadVars *tv, Packet *p, uint8_t *pkt, uint16_t len)
 {
     uint16_t plen = len;
diff --git a/src/decode-tcp.h b/src/decode-tcp.h
index 413de1b..9195dfe 100644
--- a/src/decode-tcp.h
+++ b/src/decode-tcp.h
@@ -137,9 +137,134 @@ typedef struct TCPCache_ {
     (p)->tcpc.ts2 = 0; \
 }
 
-inline uint16_t TCPCalculateChecksum(uint16_t *, uint16_t *, uint16_t);
-inline uint16_t TCPV6CalculateChecksum(uint16_t *, uint16_t *, uint16_t);
+static inline uint16_t TCPCalculateChecksum(uint16_t *, uint16_t *, uint16_t);
+static inline uint16_t TCPV6CalculateChecksum(uint16_t *, uint16_t *, uint16_t);
 void DecodeTCPRegisterTests(void);
 
+/** ------ inline functions ------ */
+
+/**
+ * \brief Calculates the checksum for the TCP packet
+ *
+ * \param shdr Pointer to source address field from the IP packet.  Used as a
+ *             part of the psuedoheader for computing the checksum
+ * \param pkt  Pointer to the start of the TCP packet
+ * \param hlen Total length of the TCP packet(header + payload)
+ *
+ * \retval csum Checksum for the TCP packet
+ */
+static inline uint16_t TCPCalculateChecksum(uint16_t *shdr, uint16_t *pkt,
+                                     uint16_t tlen)
+{
+    uint16_t pad = 0;
+    uint32_t csum = shdr[0];
+
+    csum += shdr[1] + shdr[2] + shdr[3] + htons(6 + tlen);
+
+    csum += pkt[0] + pkt[1] + pkt[2] + pkt[3] + pkt[4] + pkt[5] + pkt[6] +
+        pkt[7] + pkt[9];
+
+    tlen -= 20;
+    pkt += 10;
+
+    while (tlen >= 32) {
+        csum += pkt[0] + pkt[1] + pkt[2] + pkt[3] + pkt[4] + pkt[5] + pkt[6] +
+            pkt[7] + pkt[8] + pkt[9] + pkt[10] + pkt[11] + pkt[12] + pkt[13] +
+            pkt[14] + pkt[15];
+        tlen -= 32;
+        pkt += 16;
+    }
+
+    while(tlen >= 8) {
+        csum += pkt[0] + pkt[1] + pkt[2] + pkt[3];
+        tlen -= 8;
+        pkt += 4;
+    }
+
+    while(tlen >= 4) {
+        csum += pkt[0] + pkt[1];
+        tlen -= 4;
+        pkt += 2;
+    }
+
+    while (tlen > 1) {
+        csum += pkt[0];
+        pkt += 1;
+        tlen -= 2;
+    }
+
+    if (tlen == 1) {
+        *(uint8_t *)(&pad) = (*(uint8_t *)pkt);
+        csum += pad;
+    }
+
+    csum = (csum >> 16) + (csum & 0x0000FFFF);
+
+    return (uint16_t) ~csum;
+}
+
+/**
+ * \brief Calculates the checksum for the TCP packet
+ *
+ * \param shdr Pointer to source address field from the IPV6 packet.  Used as a
+ *             part of the psuedoheader for computing the checksum
+ * \param pkt  Pointer to the start of the TCP packet
+ * \param tlen Total length of the TCP packet(header + payload)
+ *
+ * \retval csum Checksum for the TCP packet
+ */
+static inline uint16_t TCPV6CalculateChecksum(uint16_t *shdr, uint16_t *pkt,
+                                       uint16_t tlen)
+{
+    uint16_t pad = 0;
+    uint32_t csum = shdr[0];
+
+    csum += shdr[1] + shdr[2] + shdr[3] + shdr[4] + shdr[5] + shdr[6] +
+        shdr[7] + shdr[8] + shdr[9] + shdr[10] + shdr[11] + shdr[12] +
+        shdr[13] + shdr[14] + shdr[15] + htons(6 + tlen);
+
+    csum += pkt[0] + pkt[1] + pkt[2] + pkt[3] + pkt[4] + pkt[5] + pkt[6] +
+        pkt[7] + pkt[9];
+
+    tlen -= 20;
+    pkt += 10;
+
+    while (tlen >= 32) {
+        csum += pkt[0] + pkt[1] + pkt[2] + pkt[3] + pkt[4] + pkt[5] + pkt[6] +
+            pkt[7] + pkt[8] + pkt[9] + pkt[10] + pkt[11] + pkt[12] + pkt[13] +
+            pkt[14] + pkt[15];
+        tlen -= 32;
+        pkt += 16;
+    }
+
+    while(tlen >= 8) {
+        csum += pkt[0] + pkt[1] + pkt[2] + pkt[3];
+        tlen -= 8;
+        pkt += 4;
+    }
+
+    while(tlen >= 4) {
+        csum += pkt[0] + pkt[1];
+        tlen -= 4;
+        pkt += 2;
+    }
+
+    while (tlen > 1) {
+        csum += pkt[0];
+        pkt += 1;
+        tlen -= 2;
+    }
+
+    if (tlen == 1) {
+        *(uint8_t *)(&pad) = (*(uint8_t *)pkt);
+        csum += pad;
+    }
+
+    csum = (csum >> 16) + (csum & 0x0000FFFF);
+
+    return (uint16_t) ~csum;
+}
+
+
 #endif /* __DECODE_TCP_H__ */
 
diff --git a/src/decode-udp.c b/src/decode-udp.c
index 7753e9b..12b093f 100644
--- a/src/decode-udp.c
+++ b/src/decode-udp.c
@@ -8,126 +8,6 @@
 #include "util-debug.h"
 #include "flow.h"
 
-/**
- * \brief Calculates the checksum for the UDP packet
- *
- * \param shdr Pointer to source address field from the IP packet.  Used as a
- *             part of the psuedoheader for computing the checksum
- * \param pkt  Pointer to the start of the UDP packet
- * \param hlen Total length of the UDP packet(header + payload)
- *
- * \retval csum Checksum for the UDP packet
- */
-inline uint16_t UDPV4CalculateChecksum(uint16_t *shdr, uint16_t *pkt,
-                                       uint16_t tlen)
-{
-    uint16_t pad = 0;
-    uint32_t csum = shdr[0];
-
-    csum += shdr[1] + shdr[2] + shdr[3] + htons(17 + tlen);
-
-    csum += pkt[0] + pkt[1] + pkt[2];
-
-    tlen -= 8;
-    pkt += 4;
-
-    while (tlen >= 32) {
-        csum += pkt[0] + pkt[1] + pkt[2] + pkt[3] + pkt[4] + pkt[5] + pkt[6] +
-            pkt[7] + pkt[8] + pkt[9] + pkt[10] + pkt[11] + pkt[12] + pkt[13] +
-            pkt[14] + pkt[15];
-        tlen -= 32;
-        pkt += 16;
-    }
-
-    while(tlen >= 8) {
-        csum += pkt[0] + pkt[1] + pkt[2] + pkt[3];
-        tlen -= 8;
-        pkt += 4;
-    }
-
-    while(tlen >= 4) {
-        csum += pkt[0] + pkt[1];
-        tlen -= 4;
-        pkt += 2;
-    }
-
-    while (tlen > 1) {
-        csum += pkt[0];
-        pkt += 1;
-        tlen -= 2;
-    }
-
-    if (tlen == 1) {
-        *(uint8_t *)(&pad) = (*(uint8_t *)pkt);
-        csum += pad;
-    }
-
-    csum = (csum >> 16) + (csum & 0x0000FFFF);
-
-    return (uint16_t) ~csum;
-}
-
-/**
- * \brief Calculates the checksum for the UDP packet
- *
- * \param shdr Pointer to source address field from the IPV6 packet.  Used as a
- *             part of the psuedoheader for computing the checksum
- * \param pkt  Pointer to the start of the UDP packet
- * \param tlen Total length of the UDP packet(header + payload)
- *
- * \retval csum Checksum for the UDP packet
- */
-inline uint16_t UDPV6CalculateChecksum(uint16_t *shdr, uint16_t *pkt,
-                                       uint16_t tlen)
-{
-    uint16_t pad = 0;
-    uint32_t csum = shdr[0];
-
-    csum += shdr[1] + shdr[2] + shdr[3] + shdr[4] + shdr[5] + shdr[6] +
-        shdr[7] + shdr[8] + shdr[9] + shdr[10] + shdr[11] + shdr[12] +
-        shdr[13] + shdr[14] + shdr[15] + htons(17 + tlen);
-
-    csum += pkt[0] + pkt[1] + pkt[2];
-
-    tlen -= 8;
-    pkt += 4;
-
-    while (tlen >= 32) {
-        csum += pkt[0] + pkt[1] + pkt[2] + pkt[3] + pkt[4] + pkt[5] + pkt[6] +
-            pkt[7] + pkt[8] + pkt[9] + pkt[10] + pkt[11] + pkt[12] + pkt[13] +
-            pkt[14] + pkt[15];
-        tlen -= 32;
-        pkt += 16;
-    }
-
-    while(tlen >= 8) {
-        csum += pkt[0] + pkt[1] + pkt[2] + pkt[3];
-        tlen -= 8;
-        pkt += 4;
-    }
-
-    while(tlen >= 4) {
-        csum += pkt[0] + pkt[1];
-        tlen -= 4;
-        pkt += 2;
-    }
-
-    while (tlen > 1) {
-        csum += pkt[0];
-        pkt += 1;
-        tlen -= 2;
-    }
-
-    if (tlen == 1) {
-        *(uint8_t *)(&pad) = (*(uint8_t *)pkt);
-        csum += pad;
-    }
-
-    csum = (csum >> 16) + (csum & 0x0000FFFF);
-
-    return (uint16_t) ~csum;
-}
-
 static int DecodeUDPPacket(ThreadVars *t, Packet *p, uint8_t *pkt, uint16_t len)
 {
     if (len < UDP_HEADER_LEN) {
diff --git a/src/decode-udp.h b/src/decode-udp.h
index 691f2f8..833fb8c 100644
--- a/src/decode-udp.h
+++ b/src/decode-udp.h
@@ -33,8 +33,131 @@ typedef struct UDPCache_ {
     int32_t comp_csum;
 } UDPCache;
 
-inline uint16_t UDPV4CalculateChecksum(uint16_t *, uint16_t *, uint16_t);
-inline uint16_t UDPV6CalculateChecksum(uint16_t *, uint16_t *, uint16_t);
+static inline uint16_t UDPV4CalculateChecksum(uint16_t *, uint16_t *, uint16_t);
+static inline uint16_t UDPV6CalculateChecksum(uint16_t *, uint16_t *, uint16_t);
 void DecodeUDPV4RegisterTests(void);
 
+/** ------ inline functions ------ */
+
+/**
+ * \brief Calculates the checksum for the UDP packet
+ *
+ * \param shdr Pointer to source address field from the IP packet.  Used as a
+ *             part of the psuedoheader for computing the checksum
+ * \param pkt  Pointer to the start of the UDP packet
+ * \param hlen Total length of the UDP packet(header + payload)
+ *
+ * \retval csum Checksum for the UDP packet
+ */
+static inline uint16_t UDPV4CalculateChecksum(uint16_t *shdr, uint16_t *pkt,
+                                       uint16_t tlen)
+{
+    uint16_t pad = 0;
+    uint32_t csum = shdr[0];
+
+    csum += shdr[1] + shdr[2] + shdr[3] + htons(17 + tlen);
+
+    csum += pkt[0] + pkt[1] + pkt[2];
+
+    tlen -= 8;
+    pkt += 4;
+
+    while (tlen >= 32) {
+        csum += pkt[0] + pkt[1] + pkt[2] + pkt[3] + pkt[4] + pkt[5] + pkt[6] +
+            pkt[7] + pkt[8] + pkt[9] + pkt[10] + pkt[11] + pkt[12] + pkt[13] +
+            pkt[14] + pkt[15];
+        tlen -= 32;
+        pkt += 16;
+    }
+
+    while(tlen >= 8) {
+        csum += pkt[0] + pkt[1] + pkt[2] + pkt[3];
+        tlen -= 8;
+        pkt += 4;
+    }
+
+    while(tlen >= 4) {
+        csum += pkt[0] + pkt[1];
+        tlen -= 4;
+        pkt += 2;
+    }
+
+    while (tlen > 1) {
+        csum += pkt[0];
+        pkt += 1;
+        tlen -= 2;
+    }
+
+    if (tlen == 1) {
+        *(uint8_t *)(&pad) = (*(uint8_t *)pkt);
+        csum += pad;
+    }
+
+    csum = (csum >> 16) + (csum & 0x0000FFFF);
+
+    return (uint16_t) ~csum;
+}
+
+/**
+ * \brief Calculates the checksum for the UDP packet
+ *
+ * \param shdr Pointer to source address field from the IPV6 packet.  Used as a
+ *             part of the psuedoheader for computing the checksum
+ * \param pkt  Pointer to the start of the UDP packet
+ * \param tlen Total length of the UDP packet(header + payload)
+ *
+ * \retval csum Checksum for the UDP packet
+ */
+static inline uint16_t UDPV6CalculateChecksum(uint16_t *shdr, uint16_t *pkt,
+                                       uint16_t tlen)
+{
+    uint16_t pad = 0;
+    uint32_t csum = shdr[0];
+
+    csum += shdr[1] + shdr[2] + shdr[3] + shdr[4] + shdr[5] + shdr[6] +
+        shdr[7] + shdr[8] + shdr[9] + shdr[10] + shdr[11] + shdr[12] +
+        shdr[13] + shdr[14] + shdr[15] + htons(17 + tlen);
+
+    csum += pkt[0] + pkt[1] + pkt[2];
+
+    tlen -= 8;
+    pkt += 4;
+
+    while (tlen >= 32) {
+        csum += pkt[0] + pkt[1] + pkt[2] + pkt[3] + pkt[4] + pkt[5] + pkt[6] +
+            pkt[7] + pkt[8] + pkt[9] + pkt[10] + pkt[11] + pkt[12] + pkt[13] +
+            pkt[14] + pkt[15];
+        tlen -= 32;
+        pkt += 16;
+    }
+
+    while(tlen >= 8) {
+        csum += pkt[0] + pkt[1] + pkt[2] + pkt[3];
+        tlen -= 8;
+        pkt += 4;
+    }
+
+    while(tlen >= 4) {
+        csum += pkt[0] + pkt[1];
+        tlen -= 4;
+        pkt += 2;
+    }
+
+    while (tlen > 1) {
+        csum += pkt[0];
+        pkt += 1;
+        tlen -= 2;
+    }
+
+    if (tlen == 1) {
+        *(uint8_t *)(&pad) = (*(uint8_t *)pkt);
+        csum += pad;
+    }
+
+    csum = (csum >> 16) + (csum & 0x0000FFFF);
+
+    return (uint16_t) ~csum;
+}
+
+
 #endif /* __DECODE_UDP_H__ */
diff --git a/src/decode.c b/src/decode.c
index 26a6858..7112704 100644
--- a/src/decode.c
+++ b/src/decode.c
@@ -23,26 +23,6 @@ void DecodeTunnel(ThreadVars *tv, DecodeThreadVars *dtv, Packet *p, uint8_t *pkt
     }
 }
 
-/** \brief Set the No payload inspection Flag for the packet.
- *
- * \param p Packet to set the flag in
- */
-inline void DecodeSetNoPayloadInspectionFlag(Packet *p) {
-    SCEnter();
-    p->flags |= PKT_NOPAYLOAD_INSPECTION;
-    SCReturn;
-}
-
-/** \brief Set the No packet inspection Flag for the packet.
- *
- * \param p Packet to set the flag in
- */
-inline void DecodeSetNoPacketInspectionFlag(Packet *p) {
-    SCEnter();
-    p->flags |= PKT_NOPACKET_INSPECTION;
-    SCReturn;
-}
-
 void DecodeRegisterPerfCounters(DecodeThreadVars *dtv, ThreadVars *tv)
 {
     /* register counters */
diff --git a/src/decode.h b/src/decode.h
index ee245aa..0aa2af2 100644
--- a/src/decode.h
+++ b/src/decode.h
@@ -499,9 +499,6 @@ void DecodeVLAN(ThreadVars *, DecodeThreadVars *, Packet *, uint8_t *, uint16_t,
 Packet *SetupPkt (void);
 Packet *TunnelPktSetup(ThreadVars *, DecodeThreadVars *, Packet *, uint8_t *, uint16_t, uint8_t);
 
-inline void DecodeSetNoPayloadInspectionFlag(Packet *);
-inline void DecodeSetNoPacketInspectionFlag(Packet *);
-
 #define DECODER_SET_EVENT(p, e)   ((p)->events[(e/8)] |= (1<<(e%8)))
 #define DECODER_ISSET_EVENT(p, e) ((p)->events[(e/8)] & (1<<(e%8)))
 
@@ -541,5 +538,30 @@ inline void DecodeSetNoPacketInspectionFlag(Packet *);
 #define PKT_NOPACKET_INSPECTION         0x01    /**< Flag to indicate that packet header or contents should not be inspected*/
 #define PKT_NOPAYLOAD_INSPECTION        0x02    /**< Flag to indicate that packet contents should not be inspected*/
 
+/** ------ inline functions ------ */
+static inline void DecodeSetNoPayloadInspectionFlag(Packet *);
+static inline void DecodeSetNoPacketInspectionFlag(Packet *);
+
+/** \brief Set the No payload inspection Flag for the packet.
+ *
+ * \param p Packet to set the flag in
+ */
+static inline void DecodeSetNoPayloadInspectionFlag(Packet *p) {
+    SCEnter();
+    p->flags |= PKT_NOPAYLOAD_INSPECTION;
+    SCReturn;
+}
+
+/** \brief Set the No packet inspection Flag for the packet.
+ *
+ * \param p Packet to set the flag in
+ */
+static inline void DecodeSetNoPacketInspectionFlag(Packet *p) {
+    SCEnter();
+    p->flags |= PKT_NOPACKET_INSPECTION;
+    SCReturn;
+}
+
+
 #endif /* __DECODE_H__ */
 
diff --git a/src/detect-classtype.c b/src/detect-classtype.c
index 685fd96..3e77995 100644
--- a/src/detect-classtype.c
+++ b/src/detect-classtype.c
@@ -25,47 +25,13 @@ int DetectClasstypeSetup(DetectEngineCtx *, Signature *, SigMatch *, char *);
 void DetectClasstypeRegisterTests(void);
 
 /**
- * \brief Registers the handler functions for the "Classtype" keyword.
- */
-void DetectClasstypeRegister(void)
-{
-    const char *eb = NULL;
-    int eo;
-    int opts = 0;
-
-    SCLogDebug("Registering the Classtype keyword handler");
-
-    sigmatch_table[DETECT_CLASSTYPE].name = "classtype";
-    sigmatch_table[DETECT_CLASSTYPE].Match = NULL;
-    sigmatch_table[DETECT_CLASSTYPE].Setup = DetectClasstypeSetup;
-    sigmatch_table[DETECT_CLASSTYPE].Free  = NULL;
-    sigmatch_table[DETECT_CLASSTYPE].RegisterTests = DetectClasstypeRegisterTests;
-
-    regex = pcre_compile(DETECT_CLASSTYPE_REGEX, opts, &eb, &eo, NULL);
-    if (regex == NULL) {
-        SCLogError(SC_ERR_PCRE_COMPILE, "Compile of \"%s\" failed at offset %" PRId32 ": %s",
-                   DETECT_CLASSTYPE_REGEX, eo, eb);
-        goto end;
-    }
-
-    regex_study = pcre_study(regex, 0, &eb);
-    if (eb != NULL) {
-        SCLogError(SC_ERR_PCRE_STUDY, "pcre study failed: %s", eb);
-        goto end;
-    }
-
- end:
-    return;
-}
-
-/**
  * \brief Parses the raw string supplied with the "Classtype" keyword.
  *
  * \param Pointer to the string to be parsed.
  *
  * \retval ct_name Pointer to the parsed string on Success; NULL on failure.
  */
-static inline const char *DetectClasstypeParseRawString(char *rawstr)
+static const char *DetectClasstypeParseRawString(char *rawstr)
 {
     const char *ct_name = NULL;
 #define MAX_SUBSTRINGS 30
@@ -98,25 +64,37 @@ static inline const char *DetectClasstypeParseRawString(char *rawstr)
 }
 
 /**
- * \brief Gets the classtype from the corresponding hash table stored
- *        in the Detection Engine Context, given the classtype name.
- *
- * \param ct_name Pointer to the classtype name that has to be looked up.
- * \param de_ctx  Pointer to the Detection Engine Context.
- *
- * \retval lookup_ct_info Pointer to the SCClassConfClasstype instance from
- *                        the hash table on success; NULL on failure.
+ * \brief Registers the handler functions for the "Classtype" keyword.
  */
-static inline SCClassConfClasstype *DetectClasstypeGetClasstypeInfo(const char *ct_name,
-                                                                    DetectEngineCtx *de_ctx)
+void DetectClasstypeRegister(void)
 {
-    SCClassConfClasstype *ct_info = SCClassConfAllocClasstype(ct_name, NULL,
-                                                              0);
-    SCClassConfClasstype *lookup_ct_info = HashTableLookup(de_ctx->class_conf_ht,
-                                                           ct_info, 0);
+    const char *eb = NULL;
+    int eo;
+    int opts = 0;
+
+    SCLogDebug("Registering the Classtype keyword handler");
+
+    sigmatch_table[DETECT_CLASSTYPE].name = "classtype";
+    sigmatch_table[DETECT_CLASSTYPE].Match = NULL;
+    sigmatch_table[DETECT_CLASSTYPE].Setup = DetectClasstypeSetup;
+    sigmatch_table[DETECT_CLASSTYPE].Free  = NULL;
+    sigmatch_table[DETECT_CLASSTYPE].RegisterTests = DetectClasstypeRegisterTests;
+
+    regex = pcre_compile(DETECT_CLASSTYPE_REGEX, opts, &eb, &eo, NULL);
+    if (regex == NULL) {
+        SCLogError(SC_ERR_PCRE_COMPILE, "Compile of \"%s\" failed at offset %" PRId32 ": %s",
+                   DETECT_CLASSTYPE_REGEX, eo, eb);
+        goto end;
+    }
 
-    SCClassConfDeAllocClasstype(ct_info);
-    return lookup_ct_info;
+    regex_study = pcre_study(regex, 0, &eb);
+    if (eb != NULL) {
+        SCLogError(SC_ERR_PCRE_STUDY, "pcre study failed: %s", eb);
+        goto end;
+    }
+
+ end:
+    return;
 }
 
 /**
diff --git a/src/detect-classtype.h b/src/detect-classtype.h
index 5c11e3b..fd410c2 100644
--- a/src/detect-classtype.h
+++ b/src/detect-classtype.h
@@ -5,8 +5,39 @@
 #ifndef __DETECT_CLASSTYPE_H__
 #define __DETECT_CLASSTYPE_H__
 
+#include <pcre.h>
+#include "suricata-common.h"
+#include "detect.h"
+#include "util-classification-config.h"
+
 /* prototypes */
 void DetectClasstypeRegister(void);
 
+/** ------ inline functions ------ */
+
+/**
+ * \brief Gets the classtype from the corresponding hash table stored
+ *        in the Detection Engine Context, given the classtype name.
+ *
+ * \param ct_name Pointer to the classtype name that has to be looked up.
+ * \param de_ctx  Pointer to the Detection Engine Context.
+ *
+ * \retval lookup_ct_info Pointer to the SCClassConfClasstype instance from
+ *                        the hash table on success; NULL on failure.
+ */
+static inline SCClassConfClasstype *DetectClasstypeGetClasstypeInfo(const char *ct_name,
+                                                                    DetectEngineCtx *de_ctx)
+{
+    SCClassConfClasstype *ct_info = SCClassConfAllocClasstype(ct_name, NULL,
+                                                              0);
+    SCClassConfClasstype *lookup_ct_info = HashTableLookup(de_ctx->class_conf_ht,
+                                                           ct_info, 0);
+
+    SCClassConfDeAllocClasstype(ct_info);
+    return lookup_ct_info;
+}
+
+
+
 #endif /* __DETECT_CLASSTYPE_H__ */
 
diff --git a/src/detect-content.c b/src/detect-content.c
index c924679..8e925fb 100644
--- a/src/detect-content.c
+++ b/src/detect-content.c
@@ -103,61 +103,6 @@ static void DetectContentPrintMatches(DetectEngineThreadCtx *det_ctx, DetectCont
 }
 #endif
 
-static inline int
-TestOffsetDepth(MpmMatch *m, DetectContentData *co, uint16_t pktoff) {
-    SCEnter();
-
-    if (m->offset >= pktoff) {
-        if (co->offset == 0 || (m->offset >= co->offset)) {
-            if (co->depth == 0 || ((m->offset + co->content_len) <= co->depth)) {
-                SCLogDebug("depth %" PRIu32 ", offset %" PRIu32 ", m->offset "
-                           "%" PRIu32 ", return 1", co->depth, co->offset,
-                           m->offset);
-
-                /* If we reach this point, it means we have obtained a depth and
-                 * offset match, which indicates that we have a FAILURE if the
-                 * content is negated, and SUCCESS if the content is not negated */
-                if (co->negated == 1)
-                    SCReturnInt(0);
-                else
-                    SCReturnInt(1);
-            } else {
-                /* We have success so far with offset, but a failure with
-                 * depth.  We can return a match at the bottom of this function
-                 * for negated_content, provided offset is 0.  If offset
-                 * isn't 0 for negated_content, we have a failure and we return
-                 * a no match here.  If the content is not negated, we have a no
-                 * match, which we return at the end of this function. */
-                if (co->offset && co->negated == 1)
-                    SCReturnInt(0);
-            }
-        } else {
-            /* If offset fails, and if the content is negated, we check if depth
-             * succeeds.  If it succeeds, we have a no match for negated content.
-             * Else we have a success for negated content.  If the content is
-             * not negated, we go down till the end and return a no match. */
-            if (co->negated == 1) {
-                if (co->offset != 0) {
-                    SCReturnInt(1);
-                } else if (co->depth && (m->offset+co->content_len) <= co->depth) {
-                    SCLogDebug("depth %" PRIu32 ", offset %" PRIu32 ", m->offset %" PRIu32 ", "
-                            "return 0", co->depth, co->offset, m->offset);
-                    SCReturnInt(0);
-                }
-            }
-        }
-    }
-    SCLogDebug("depth %" PRIu32 ", offset %" PRIu32 ", m->offset %" PRIu32 ", "
-               "return 0 (or 1 if negated)", co->depth, co->offset, m->offset);
-
-    /* If we reach this point, we have a match for negated content and no match
-     * otherwise */
-    if (co->negated == 1)
-        SCReturnInt(1);
-    else
-        SCReturnInt(0);
-}
-
 /**
  * \brief test the within, distance, offset and depth of a match
  *
diff --git a/src/detect-content.h b/src/detect-content.h
index 63f8208..8efa3a6 100644
--- a/src/detect-content.h
+++ b/src/detect-content.h
@@ -84,4 +84,63 @@ int DetectContentPropagateModifiers(SigMatch *);
 
 void DetectContentFree(void *);
 
+/** ------ inline functions ------ */
+
+static inline int
+TestOffsetDepth(MpmMatch *m, DetectContentData *co, uint16_t pktoff) {
+    SCEnter();
+
+    if (m->offset >= pktoff) {
+        if (co->offset == 0 || (m->offset >= co->offset)) {
+            if (co->depth == 0 || ((m->offset + co->content_len) <= co->depth)) {
+                SCLogDebug("depth %" PRIu32 ", offset %" PRIu32 ", m->offset "
+                           "%" PRIu32 ", return 1", co->depth, co->offset,
+                           m->offset);
+
+                /* If we reach this point, it means we have obtained a depth and
+                 * offset match, which indicates that we have a FAILURE if the
+                 * content is negated, and SUCCESS if the content is not negated */
+                if (co->negated == 1)
+                    SCReturnInt(0);
+                else
+                    SCReturnInt(1);
+            } else {
+                /* We have success so far with offset, but a failure with
+                 * depth.  We can return a match at the bottom of this function
+                 * for negated_content, provided offset is 0.  If offset
+                 * isn't 0 for negated_content, we have a failure and we return
+                 * a no match here.  If the content is not negated, we have a no
+                 * match, which we return at the end of this function. */
+                if (co->offset && co->negated == 1)
+                    SCReturnInt(0);
+            }
+        } else {
+            /* If offset fails, and if the content is negated, we check if depth
+             * succeeds.  If it succeeds, we have a no match for negated content.
+             * Else we have a success for negated content.  If the content is
+             * not negated, we go down till the end and return a no match. */
+            if (co->negated == 1) {
+                if (co->offset != 0) {
+                    SCReturnInt(1);
+                } else if (co->depth && (m->offset+co->content_len) <= co->depth) {
+                    SCLogDebug("depth %" PRIu32 ", offset %" PRIu32 ", m->offset %" PRIu32 ", "
+                            "return 0", co->depth, co->offset, m->offset);
+                    SCReturnInt(0);
+                }
+            }
+        }
+    }
+    SCLogDebug("depth %" PRIu32 ", offset %" PRIu32 ", m->offset %" PRIu32 ", "
+               "return 0 (or 1 if negated)", co->depth, co->offset, m->offset);
+
+    /* If we reach this point, we have a match for negated content and no match
+     * otherwise */
+    if (co->negated == 1)
+        SCReturnInt(1);
+    else
+        SCReturnInt(0);
+}
+
+
+
 #endif /* __DETECT_CONTENT_H__ */
